class CDOrganizer
    attr_accessor :cd_list, :table_header_stuff   
    def initialize 
        Struct.new("CD", :artist, :title, :year, :genre)
        @cd_list = []
        @table_header_stuff = 'Artist           Title            Genre            Year'
    end
    def add(artist, title, year, genre)
        @cd_list << Struct::CD.new(artist.upcase, title.upcase, year, genre) 
        @cd_list.sort! { |cd, other| [cd.artist, other.year.to_i] <=> [other.artist, cd.year.to_i] }
    end
    def delete(artist, title)
        @cd_list.delete_if { |cd| cd.artist == artist.upcase && cd.title == title.upcase }
    end
    def search(input, flag)
        puts
        puts @table_header_stuff
        count = 0
        @cd_list.each do |cd|
            case flag
            when 'artist'
                if cd.artist =~ /#{input}/i
                    puts build_cd_output(cd)
                    count += 1
                end
            when 'genre'
                if cd.genre.to_i == input.to_i
                    puts build_cd_output(cd) 
                    count += 1
                end
            end
        end
        puts
        puts "#{count} record(s) found."
        puts
    end
    def save(filename)
        file = File.open("../cds/#{filename}",'w')
        @cd_list.each { |cd| file.write("#{cd.artist}_#{cd.title}_#{cd.genre}_#{cd.year}\n") }
        system('clear')
        file.close
    end
    def to_s
        puts
        puts @table_header_stuff
        @cd_list.each do |cd|
            puts build_cd_output(cd)
        end
        puts
    end
    def build_cd_output(cd)
        print_space = 17
        s = ''
        s << cd.artist
        (print_space-cd.artist.length).times { s << ' ' }
        s << cd.title
        (print_space-cd.title.length).times { s << ' ' }
        s << cd.genre.to_s
        (print_space-cd.genre.to_s.length).times { s << ' ' }
        s << cd.year.to_s
    end
end
