#!/usr/bin/ruby

require_relative 'menu.rb'
require_relative 'cd_organizer.rb' 
require_relative 'genres.rb'

print_space = 10
saved = true 
system 'clear'

cd_organizer = CDOrganizer.new
print 'Please enter the filename for your CD storage collection.
If you do not yet have a collection, enter a filename where you wish your CDs to be stored.
Filename: '

# check if file exists
filename = gets.chomp
if File.file? "../cds/#{filename}"
    File.open("../cds/#{filename}", 'r').each_line do |line|
        begin
            info = line.split('_') 
            cd_organizer.add(info[0],info[1],info[3],info[2])
        rescue NoMethodError
            # do nothing, skip this line
        end 
    end
    cd_organizer.to_s 
else
    puts
    puts "There are no CDs in the collection"
    puts
end

loop do
    print_menu
    case gets.chomp.to_i
    when 1
        print 'Enter the artist: '
        artist = gets.chomp
        print 'Enter the CD title: '
        title = gets.chomp
        print 'Enter the year of the CD: '
        year = gets.chomp.to_i
        print_genres
        print 'Enter the genre number for this CD: '
        genre = gets.chomp.to_i
        cd_organizer.add(artist,title,year,genre)
        cd_organizer.to_s 
        saved = false
    when 2
        cd_organizer.to_s  
    when 3
        puts 'Search by (1) Artist or (2) Genre?'
        case gets.chomp.to_i
        when 1
            print 'Enter Arist (all or partial name): '
            input = gets.chomp
            cd_organizer.search(input, 'artist')
        when 2
            print_genres
            print 'Enter Genre # for which to search: '
            input = gets.chomp.to_i
            cd_organizer.search(input, 'genre')
        end
    when 4
        puts 'Enter the title and artist of the CD to delete'
        print 'Artist: '
        artist = gets.chomp
        print 'Title: '
        title = gets.chomp
        orig_size = cd_organizer.cd_list.length
        new_size = cd_organizer.delete(artist,title).length
        if orig_size == new_size 
            puts
            puts "**#{artist.upcase}/#{title.upcase} was not found in the list**"
            cd_organizer.to_s 
        else
            cd_organizer.to_s
            saved = false
        end
    when 5
        cd_organizer.save(filename)
        puts
        puts '**Save Successful!**'
        puts
        saved = true
    when 9
        if !saved
            puts '**WARNING** Your CD collection has changed since you last saved to disk.'
            print 'Save your changes? (y/n): '
            case gets.chomp
            when 'y','Y','yes','Yes','YES'
                cd_organizer.save(filename)
                break
            when 'n','N','no','No','NO'
                break 
            end
        end
        break
    end
end
